#include <stdio.h>
#include <stdlib.h>
#include <peekpoke.h>
#include <conio.h>  
#include <modload.h>  
#include <tgi.h>
#include <string.h>

static void CheckError (const char* S)
{
    unsigned char Error = tgi_geterror ();
    if (Error != TGI_ERR_OK) {
        printf ("%s: %d\n", S, Error);
        exit (EXIT_FAILURE);
    }
}


void printNumber(unsigned int n)
{
unsigned char d1,d2,d3;
  if(n>99)
  {
  d1=n/100;
  }
  else
  {
  d1=0;
  }

  if(n>9)
  {
  d2=(n/10)-d1*10;
  }
  else
  {
  d2=0;
  }

  d3=n-(d2*10)-(d1*100);
  gotox(10);
  printf("%d.%d%d V",d1,d2,d3);
}

unsigned char readUserport()
{

unsigned char a,b,c,d,i;

// CS (PB2) auf high
  b=PEEK(56577) | 4;
  POKE(56577,b);

// CS (PB2) auf low
  b=PEEK(56577);
  if( (b & 4) > 0)
  {
  b=b-4;
  POKE(56577,b);
  }


c=128;
d=0;
  for(i=0;i<8;i++)
  {
  // bit auslesen
  a=PEEK(56577) & 1;
    if(a>0)
    {
    d=d+c;
    }
  c=c/2;
  // clock (PB1) auf high
  b=PEEK(56577) | 2;
  POKE(56577,b);
  // clock '(PB1) auf low
  b=PEEK(56577);
    if( (b & 2) > 0)
    {
    b=b-2;
    POKE(56577,b);
    }
  }
return(d);
}

void writeUserport(unsigned char d)
{
unsigned char b;
// LEDs bei bestimmten Spannugnswerten einschalten
  b=PEEK(56577);

    if(d<50)
    {
    b=b | 8;
    }
    else
    {
      if( (b & 8) > 0)
      {
      b=b-8;
      }
    }

    if(d >= 51 && d < 102)
    {
    b=b | 16;
    }
    else
    {
      if( (b & 16) > 0)
      {
      b=b-16;
      }
    }

    if(d >= 102 && d < 153)
    {
    b=b | 32;
    }
    else
    {
      if( (b & 32) > 0)
      {
      b=b-32;
      }
    }

    if(d >=153 && d < 204)
    {
    b=b | 64;
    }
    else
    {
      if( (b & 64) > 0)
      {
      b=b-64;
      }
    }

    if(d >= 204)
    {
    b=b | 128;
    }
    else
    {
      if( (b & 128) > 0)
      {
      b=b-128;
      }
    }
POKE(56577,b);
}




void main(void)
{
unsigned char b,d,f;
unsigned char switch1;
char key1, tgi1;
int i,rand1,delay=1,delaycount=64;



tgi1=0;
switch1=0;
i=1;
d=128;

POKE(56579,254);
POKE(56577,0);

bordercolor(0);
bgcolor(0);
textcolor(5);

printf("\f");
printf("\n \n");
printf("Spannung: %d.%d%d V",0,0,0);
f=0;

// alle 5 LEDs ausschalten
b=PEEK(56577) & 7;
POKE(56577,b);

// clock (PB1)  auf low 
  b=PEEK(56577);
  if( (b & 2) > 0)
  {
  b=b-2;
  POKE(56577,b);
  }

start1:
 d=readUserport();
/*  
  rand1=rand();
  if(rand1>16384)
  {
  d=d+1;
  }
  else
  {
  d=d-1;
  }
    if(d>=255)
    {
    d=d-2;
    }
    if(d<1)
    {
    d=d+2;
    }
*/

writeUserport(d);
// wert ausgeben
//printNumber(d*100/51);

  if(kbhit()==1)
  {
  key1=cgetc();
    if(key1=='-')
    {
      if((delaycount*2)<=512)
      {
      delaycount*=2;
      }
    }

    if(key1=='+')
    {
    delaycount/=2;
      if(delaycount<=0)
      {
      delaycount=1;
      }
    }
 
    if(key1=='1')
    {
    switch1=0;
      if(tgi1==1)
      {
      tgi1=0;
      tgi_clear ();
      tgi_unload ();
      // bordercolor(0);
      //  bgcolor(0);
      // textcolor(5);
      }
    printf("\f");
    printf("\n \n");
    printf("Spannung: %d.%d%d V",0,0,0);
    }

    if(key1==' ')
    {
      if(switch1==1)
      {
      tgi_clear ();

      tgi_line (10, 10, 10, 190);
      tgi_lineto (310, 190);
      tgi_line (8, 12, 10, 10);
      tgi_lineto (12, 12);
      tgi_line (320-12, 200-12, 320-10, 200-10);
      tgi_lineto (320-12, 200-8);
       tgi_line(15,30+(d/5*3),15,30+(d/5*3));
      i=1;
      }
    }

    if(key1=='2')
    {
      if(tgi1==0)
      {
      tgi1=1;
      tgi_load_driver (tgi_stddrv);
     //  CheckError ("tgi_load_driver");
      tgi_init ();
      tgi_clear ();

      tgi_line (10, 10, 10, 190);
      tgi_lineto (310, 190);
      tgi_line (8, 12, 10, 10);
      tgi_lineto (12, 12);
      tgi_line (320-12, 200-12, 320-10, 200-10);
      tgi_lineto (320-12, 200-8);
       tgi_line(15,30+(d/5*3),15,30+(d/5*3));
      }
    i=1;
    switch1=1;
    } 
  }

  if(switch1==0)
  {
  printNumber(d*100/51);
  }

  if(switch1==1)
  {
    if(delay==0)
    {
     if(i>=300)
     {
     i=1;
     tgi_clear();
     tgi_line (10, 10, 10, 190);
     tgi_lineto (310, 190);
     tgi_line (8, 12, 10, 10);
     tgi_lineto (12, 12);
     tgi_line (320-12, 200-12, 320-10, 200-10);
     tgi_lineto (320-12, 200-8);
     tgi_line(15,30+(d/5*3),15,30+(d/5*3));
     }
     tgi_lineto(i+15,30+(d/5*3));
 //    tgi_setpixel (i+15,180-(d/5*3));
    i++;
    }

  delay++;
  if(delay>=delaycount)
  {
  delay=0;
  }

  }


goto start1;
}
